from DateTime import DateTime
import zLOG, os, string
import re, random
from urllib import quote_plus
from cStringIO import StringIO
from Products.CMFCore.utils import getToolByName
try:
    from Products.RegisterMembership.RegisteredMemberProfile import RegisteredMemberProfile
    useProfile = 1
except:
    useProfile = 0
    
try:
    from Products.zGuestBook.zGuestBook import zGuestBook
    useGuestBook = 1
except:
    useGuestBook = 0

out = StringIO()
DEFAULT_PROFILE_ID = 'member_profile'
DEFAULT_GUESTBOOK_ID = 'My_Guestbook'

def cookId(id, separator=""):
    if not id:
        id = str(DateTime().millis()) + str(random.randint(0, 1000000))
    else:
        id = id.replace('','ae')
        id = id.replace('','oe')
        id = id.replace('','aa')
        id = id.replace('','Ae')
        id = id.replace('','Oe')
        id = id.replace('','Aa')
        rgx = re.compile(r'(^_|[^a-zA-Z0-9-_~\,\.])')
        id = re.sub(rgx, separator, id)
    return id
    
def getUniqueID():
    return cookId(id=None)

def getNewID(self, id):
    return self._get_id(id)

def urlencode(str):
    return quote_plus(str)

def gotattr(obj, attr):
    return hasattr(obj, attr)

def getTransitions(self):
    out = StringIO()
    #out.write('Testing Get Transitions\n')
    #out.write('-----------------------\n\n')
    wf_tool = getToolByName(self, 'portal_workflow')
    transitionlist = []
    for id in wf_tool.getWorkflowIds():
        #out.write('ID: %s\n' % id)
        if id != 'collector_issue_workflow':
            wf = wf_tool.getWorkflowById(id)
            #out.write('Workflow dict: %s\n' % str(wf.__dict__))
            if hasattr(wf, 'transitions'):
                #out.write('Transitions dict: %s\n' % str(wf.transitions.__dict__))
                if hasattr(wf.transitions, '_mapping'):
                    for transition in wf.transitions._mapping.keys():
                        transition_dict = {}
                        tlist_def = wf.transitions._mapping[transition]
                        tranid = tlist_def.getId()
                        guard = tlist_def.getGuard()
                        #out.write('Guard Definition dict for transition %s: %s\n' % (str(tranid), str(guard.__dict__)))
                        #out.write('Transition list: %s\n\n' % str(tlist_def))
                        a_tlist = {'id': tranid
                        ,}
                        name =  getattr(tlist_def, 'actbox_name', None)
                        if name: a_tlist['name'] = name
                        transition_dict['id'] = tranid
                        transition_dict['name'] = name
                        transition_dict['permission'] = guard.permissions
                        transition_dict['roles'] = guard.roles
                        transitionlist.append(transition_dict)

    actionlist = []
    for dict in transitionlist:
        add_new = 1
        for final_dict in actionlist:
            if final_dict['id'] == dict['id']:
                add_new = 0
        if add_new:
            new_dict = {}
            new_dict['id'] = dict['id']
            new_dict['name'] = dict['name']
            permlist = []
            for perm in dict['permission']:
                permlist.append(perm)
            new_dict['permission'] = permlist
            roleslist = []
            for role in dict['roles']:
                roleslist.append(role)
            new_dict['roles'] = roleslist
            actionlist.append(new_dict)

    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))

    if not actionlist:
        actionlist = [{'id': 'publish'
                     , 'name': 'Publish'
                     , 'permission': ['Review portal content']
                      }
                    , {'id': 'submit'
                     , 'name': 'Submit'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'retract'
                     , 'name': 'Retract'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'reject'
                     , 'name': 'Reject'
                     , 'permission': ['Review portal content']
                      }]

    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))
    return actionlist

def updateMemberAreas(self):
    """
    WARNING:
    This function will update the members member area.
    """
    portal_url = getToolByName(self, 'portal_url')
    portal = portal_url.getPortalObject()
    lt = getToolByName(self, 'portal_layout')
    mtool = getToolByName(self, 'portal_membership')
    members = getattr(portal, 'Members')
    if 'portal_typefilter' in portal.objectIds():
        typefilter = getToolByName(self, 'portal_typefilter')
    else:
        typefilter = None
    out.write("Updating member areas\n\n")
    
    for memfolder in members.objectValues('Membership Member Folder'):
        out.write("Updating area for %s\n" % memfolder.Creator())
        member = mtool.getMemberById(memfolder.Creator())
        if member:
            user = member.getUser()
            member_id = member.getUserName()
            out.write("Updating area for %s\n" % member_id)
            locals = lt.getLocalLayoutColumns(memfolder, aquire=0)
            if locals:
                out.write("Deleting local columns in member folder\n")
                for local in locals:
                    memfolder.manage_delObjects(local.getId())
            lt.addLocalLayoutColumn(memfolder)
            lt.addLocalLayoutColumn(memfolder)
            locals = lt.getLocalLayoutColumns(memfolder, aquire=0)
            leftcol = locals[0]
            rightcol = locals[1]
            out.write("Added local columns in member folder\n")
        
            leftcol.edit(width='50%', title='Left side')
            if useProfile:
                if 'guestbook' in memfolder.objectIds():
                    memfolder.manage_delObjects('guestbook')
                if not DEFAULT_PROFILE_ID in memfolder.objectIds():
                    profileobj = RegisteredMemberProfile(id=DEFAULT_PROFILE_ID)
                    memfolder._setObject(DEFAULT_PROFILE_ID, profileobj)
                    profile = getattr(memfolder, DEFAULT_PROFILE_ID)
                    if hasattr(profile, '_setPortalTypeName'):
                        profile._setPortalTypeName('Member Profile')
                    profile.changeOwnership(user)
                    profile.manage_setLocalRoles(member_id, ['Owner'])
                    profile.reindexObject()
                    out.write("Added profile in member folder\n")
                else:
                    profile = getattr(memfolder, DEFAULT_PROFILE_ID)
                    out.write("A profile already existed in the member folder\n")
                leftcol.addLayout('Content Element', layout_title='My Profile')
                contentmenu = leftcol.getLayoutElements()[0]
                profilepath = string.join(profile.getPhysicalPath(), '/')
                contentmenu.setContent(contentpath=profilepath)
            if useGuestBook:
                if not DEFAULT_GUESTBOOK_ID in memfolder.objectIds():
                    guestbookobj = zGuestBook(id=DEFAULT_GUESTBOOK_ID, title='My Guestbook')
                    memfolder._setObject(DEFAULT_GUESTBOOK_ID, guestbookobj)
                    guestbook = getattr(memfolder, DEFAULT_GUESTBOOK_ID)
                    if hasattr(guestbook, '_setPortalTypeName'):
                        guestbook._setPortalTypeName('Guest Book')
                    guestbook.changeOwnership(user)
                    guestbook.manage_setLocalRoles(member_id, ['Owner'])
                    guestbook.reindexObject()
                    out.write("Added guestbook in member folder\n")
                else:
                    guestbook = getattr(memfolder, DEFAULT_GUESTBOOK_ID)
                    out.write("A guestbook already existed in the member folder\n")
                leftcol.addLayout('Content Element', layout_title='My Guestbook')
                contentmenu = leftcol.getLayoutElements()[1]
                contentmenu.setRenderHeader(render=None)
                contentmenu.setRenderTitle(render=None)
                guestbookpath = string.join(guestbook.getPhysicalPath(), '/')
                contentmenu.setContent(contentpath=guestbookpath)
            
            
            rightcol.edit(width='50%', title='Left side')
            if member_id[-1:] == 's':
                listbox_title = "%s' stuff" % member_id
            else:
                listbox_title = "%s's stuff" % member_id
            rightcol.addLayout('List Box', layout_title=listbox_title)
            listbox = rightcol.getLayoutElements()[0]
            listbox.setItemCount(15)
            listbox.setTypes(['Link', 'Media Event', 'Article', 'Photo Album', 'Guest Book'])
            try:
                def_format = mtool.getDefaultListboxFormat()
                if def_format:
                    listbox.setFormat(def_format)
            except:
                pass
            try:
                listbox.setUserOrGroupSearch('page_owner')
            except:
                pass
            listbox.setSearch('site')
            out.write("Finished updating member area\n\n")
    return out.getvalue()
