##############################################################################
#    Copyright (C) 2002-03 MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

import os, zLOG
from Globals import package_home
from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from Products.PageTemplates import PageTemplateFile
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import _getViewFor
from Products.CMFPortalLayout.LayoutBase import LayoutBase
from Products.CMFPortalLayout.LayoutTool import registerLayoutType
from Products.CMFPortalLayout.utils import getUniqueId, getIdFromPath
from Products.CMFPortalLayout.LayoutTool import _zptdir

#_zptdir = os.path.join(package_home(globals()), 'www')

class GhostElement(LayoutBase):
    """
    An object containing the information for creating a list box.
    """
    security = ClassSecurityInfo()
    meta_type = 'Ghost Element'
    manage_options = (
                       (
                         { 'label':'View','action':'manage_configuration' }
                      ,) +
                         SimpleItem.manage_options
                     )

    security.declareProtected(CMFCorePermissions.ManagePortal, 'manage_configuration')
    manage_configuration = PageTemplateFile.PageTemplateFile('manageGhostElement', _zptdir)

    def __init__(self, referer_path, title='', ):
        """
        Create a new ghost element
        """
        self.id = getUniqueId()
        self.setTitle(title)
        self._referer_path = referer_path

    def __call__(self):
        '''
        Invokes the default view of the object this element refers to.
        '''
        portal = getToolByName(self, 'portal_url').getPortalObject()
        obj = portal.restrictedTraverse(self._referer_path)
        return obj.__call__()

    view = __call__

    index_html = None  # This special value informs ZPublisher to use __call__

    security.declarePublic('Type')
    def Type(self):
        """
        Usually returns the metatype
        """
        obj = self.getReferenceObject()
        reftype = obj.Type()
        return "Portal Element (%s)" % reftype

    security.declareProtected(CMFCorePermissions.ManageProperties, 'getReferencePath')
    def getReferencePath(self):
        """
        Return the path to the reference object
        """
        return self._referer_path

    security.declareProtected(CMFCorePermissions.ManageProperties, 'getReferenceObject')
    def getReferenceObject(self):
        """
        Return the references layout object
        """
        portal = getToolByName(self, 'portal_url').getPortalObject()
        return portal.restrictedTraverse(self._referer_path)

registerLayoutType(GhostElement)
