##############################################################################
#    Copyright (C) 2003  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

import os, zLOG, sys, traceback, string
from Globals import InitializeClass, package_home
from AccessControl import getSecurityManager, ClassSecurityInfo
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions
from DateTime import DateTime
from Products.CMFPortalLayout.LayoutBase import LayoutBase
from Products.CMFPortalLayout.LayoutTool import registerLayoutType
from Products.CMFPortalLayout.utils import getUniqueId

class SpacerElement(LayoutBase):
    """
    A menu containing breadcrumbs
    """
    _edit_method = 'spacerelement_edit_form'
    _view_method = 'spacerelement_view'
    _height = 0
    _width = 0

    security = ClassSecurityInfo()
    type = 'Spacer Element'
    meta_type = 'Spacer Element'

    def __init__(self, title=''):
        """
        Create a new breadcrumbs object.
        """
        self.id = getUniqueId()
        self.setTitle(title)
        self._height = 0
        self._width = 0

    security.declareProtected(CMFCorePermissions.ManageProperties, 'edit')
    def edit(self, REQUEST):
        """
        Set the menus properties
        """
        self.setTitle(REQUEST.get('title', None))
        self.setHeight(REQUEST.get('height', None))
        self.setWidth(REQUEST.get('width', None))

        parent = self.getParent()
        msg = 'Saved spacer element'
        req = REQUEST
        returnurl = req.get('returnToUrl', None)
        if not returnurl:
            returnurl = "%s/spacerelement_edit_form" % self.absolute_url()
        req.RESPONSE.redirect('%s?portal_status_message=%s' % (returnurl, msg.replace(' ', '+')))

    security.declarePrivate('setHeight')
    def setHeight(self, height=None):
        """
        Set the height in pixels for the spacer element
        """
        zLOG.LOG(self.meta_type, zLOG.INFO, 'Height is %s' % str(height))
        if height is not None:
            self._height = int(height)

    security.declarePublic('getHeight')
    def getHeight(self):
        """
        Return the height of the spacer element
        """
        return int(self._height)

    security.declarePrivate('setWidth')
    def setWidth(self, width=None):
        """
        Set the width in pixels for the spacer element
        """
        if width is not None:
            self._width = int(width)

    security.declarePublic('getWidth')
    def getWidth(self):
        """
        Return the width of the spacer element
        """
        return int(self._width)

registerLayoutType(SpacerElement)
